clc
clear
close all

global data
global n
upperBand=1000;
lowerBand=50;
itter=50;
QualityName = {'Availability','Reliability','Throughput','Reputation','ResponseTime','Price','Bandwith','Delivery','Latency'};
ServiceName = {'Firewall','NAT','LI','DDos','WOC','PNG','OLT','CMTS','PGW'};
for i=1:upperBand
    ServiceName{i} = ['s' num2str(i)];
end
ServiceClassName = {'A', 'B', 'C'};

w = ones(10, 1);
n = 3;

index = 1;

for numServiceCondidate = lowerBand:itter:upperBand
    filename = 'data\mydataIndependent.csv';
    delimiterIn=',';alldata = importdata(filename, delimiterIn);
    data = alldata(1:numServiceCondidate, :);
    [allResLP(index, :), allValMax(index, 1), alltime(index, 1)] = myLP(n, numServiceCondidate);
    [allResGA(index, :), allValMax(index, 2), alltime(index, 2)] = mainGA(n, numServiceCondidate);
    [allResKMEANS(index, :), allValMax(index, 4), alltime(index, 4)] = mainBuildRepresentativesHeapTree(data, n, w);
    switch n
        case 2
           filename = 'data\skyIndependent-grammar-n2.csv';
        case 3
           filename = 'data\skyIndependent-grammar-n3.csv';
        case 4
            filename = 'data\skyIndependent-grammar-n4.csv';
    end
    
    delimiterIn=',';alldata = importdata(filename, delimiterIn);
    data = alldata(1:numServiceCondidate, :);
    [allResGA(index, :), allValMax(index, 3), alltime(index, 3)] = mainGrammar(n, numServiceCondidate);
    index = index + 1;
end

figure, plot(lowerBand:itter:upperBand, log(alltime(:,1)));
hold on
plot(lowerBand:itter:upperBand, log(alltime(:, 2)));
plot(lowerBand:itter:upperBand, log(alltime(:, 3)));
plot(lowerBand:itter:upperBand, log(alltime(:, 4)));

title('Independent Data')
xlabel('number of Service Condidates per Class');
ylabel('Logarithmic Computation Time (sec)');
legend('ILP', 'GA', 'SGGA','Kmeans');

figure, plot(lowerBand:itter:upperBand, 1-allValMax(:,1)/n);
hold on
plot(lowerBand:itter:upperBand, 1-allValMax(:, 2)/n);
plot(lowerBand:itter:upperBand, 1-allValMax(:, 3)/n);
plot(lowerBand:itter:upperBand, 1-allValMax(:, 4)/n);

title('Independent Data')
xlabel('number of Service Condidates per Class');
ylabel('QOS');
legend('ILP', 'GA', 'SGGA','Kmeans');

clear data filename i allCompositions allCompositionsQOS numComposions allResKMEANS allValMax
clear indexMin index  valMin numServiceCondidate indexService alldata allResLP allResGA alltime



index = 1;
for numServiceCondidate = lowerBand:itter:upperBand
    filename = 'data\mydataCorrelated.csv';
    delimiterIn=',';alldata = importdata(filename, delimiterIn);
    data = alldata(1:numServiceCondidate, :);
    [allResLP(index, :), allValMax(index, 1), alltime(index, 1)] = myLP(n, numServiceCondidate);
    [allResGA(index, :), allValMax(index, 2), alltime(index, 2)] = mainGA(n, numServiceCondidate);
    [allResKMEANS(index, :), allValMax(index, 4), alltime(index, 4)] = mainBuildRepresentativesHeapTree(data, n, w);
    switch n
        case 2
           filename = 'data\skyCorrelated-grammar-n2.csv';
        case 3
           filename = 'data\skyCorrelated-grammar-n3.csv';
        case 4
            filename = 'data\skyCorrelated-grammar-n4.csv';
    end
    
    delimiterIn=',';alldata = importdata(filename, delimiterIn);
    data = alldata(1:numServiceCondidate, :);
    [allResGA(index, :), allValMax(index, 3), alltime(index, 3)] = mainGrammar(n, numServiceCondidate);
    index = index + 1;
    
end

figure, plot(lowerBand:itter:upperBand, log(alltime(:,1)));
hold on
plot(lowerBand:itter:upperBand, log(alltime(:, 2)));
plot(lowerBand:itter:upperBand, log(alltime(:, 3)));
plot(lowerBand:itter:upperBand, log(alltime(:, 4)));

title('Corrolated Data')
xlabel('number of Service Condidates per Class');
ylabel('Logarithmic Computation Time (sec)');
legend('ILP', 'GA', 'SGGA','Kmeans');

figure, plot(lowerBand:itter:upperBand, 1-allValMax(:,1)/n);
hold on
plot(lowerBand:itter:upperBand, 1-allValMax(:, 2)/n);
plot(lowerBand:itter:upperBand, 1-allValMax(:, 3)/n);
plot(lowerBand:itter:upperBand, 1-allValMax(:, 4)/n);

title('Corrolated Data')
xlabel('number of Service Condidates per Class');
ylabel('QOS');
legend('ILP', 'GA', 'SGGA','Kmeans');


clear data filename i allCompositions allCompositionsQOS numComposions allResKMEANS allValMax
clear indexMin index  valMin numServiceCondidate indexService alldata allResLP allResGA alltime


index = 1;
for numServiceCondidate = lowerBand:itter:upperBand
    filename = 'data\mydataAntiCorrelated.csv';
    delimiterIn=',';alldata = importdata(filename, delimiterIn);
    data = alldata(1:numServiceCondidate, :);
    [allResLP(index, :), allValMax(index, 1), alltime(index, 1)] = myLP(n, numServiceCondidate);
    [allResGA(index, :), allValMax(index, 2), alltime(index, 2)] = mainGA(n, numServiceCondidate);
    [allResKMEANS(index, :), allValMax(index, 4), alltime(index, 4)] = mainBuildRepresentativesHeapTree(data, n, w);

    switch n
        case 2
           filename = 'data\skyAnti-grammar-n2.csv';
        case 3
           filename = 'data\skyAnti-grammar-n3.csv';
        case 4
            filename = 'data\skyAnti-grammar-n4.csv';
    end
    delimiterIn=',';alldata = importdata(filename, delimiterIn);
    data = alldata(1:numServiceCondidate, :);
    [allResGA(index, :), allValMax(index, 3), alltime(index, 3)] = mainGrammar(n, numServiceCondidate);
    
    index = index + 1;
end

figure, plot(lowerBand:itter:upperBand, log(alltime(:,1)));
hold on
plot(lowerBand:itter:upperBand, log(alltime(:, 2)));
plot(lowerBand:itter:upperBand, log(alltime(:, 3)));
plot(lowerBand:itter:upperBand, log(alltime(:, 4)));

title('AntiCorrelated Data')
xlabel('number of Service Condidates per Class');
ylabel('Logarithmic Computation Time (sec)');
legend('ILP', 'GA', 'SGGA','Kmeans');

figure, plot(lowerBand:itter:upperBand, 1-allValMax(:,1)/n);
hold on
plot(lowerBand:itter:upperBand, 1-allValMax(:, 2)/n);
plot(lowerBand:itter:upperBand, 1-allValMax(:, 3)/n);
plot(lowerBand:itter:upperBand, 1-allValMax(:, 4)/n);

title('AntiCorrelated Data')
xlabel('number of Service Condidates per Class');
ylabel('QOS');
legend('ILP', 'GA', 'SGGA','Kmeans');

clear data filename i allCompositions allCompositionsQOS numComposions allResKMEANS allValMax
clear indexMin index  valMin numServiceCondidate indexService alldata allResLP allResGA alltime


